xref: /linux/scripts/link-vmlinux.sh (revision 9557b4376d02088a33e5f4116bcc324d35a3b64c)
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects in vmlinux.a and $(KBUILD_VMLINUX_LIBS).
7# vmlinux.a contains objects that are linked unconditionally.
8# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
9# (not within --whole-archive), and do not require symbol indexes added.
10#
11# vmlinux
12#   ^
13#   |
14#   +--< vmlinux.a
15#   |
16#   +--< $(KBUILD_VMLINUX_LIBS)
17#   |    +--< lib/lib.a + more
18#   |
19#   +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31LD="$1"
32KBUILD_LDFLAGS="$2"
33LDFLAGS_vmlinux="$3"
34
35is_enabled() {
36	grep -q "^$1=y" include/config/auto.conf
37}
38
39# Nice output in kbuild format
40# Will be supressed by "make -s"
41info()
42{
43	printf "  %-7s %s\n" "${1}" "${2}"
44}
45
46# Link of vmlinux
47# ${1} - output file
48vmlinux_link()
49{
50	local output=${1}
51	local objs
52	local libs
53	local ld
54	local ldflags
55	local ldlibs
56
57	info LD ${output}
58
59	# skip output file argument
60	shift
61
62	if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
63		# Use vmlinux.o instead of performing the slow LTO link again.
64		objs=vmlinux.o
65		libs=
66	else
67		objs=vmlinux.a
68		libs="${KBUILD_VMLINUX_LIBS}"
69	fi
70
71	if is_enabled CONFIG_MODULES; then
72		objs="${objs} .vmlinux.export.o"
73	fi
74
75	objs="${objs} init/version-timestamp.o"
76
77	if [ "${SRCARCH}" = "um" ]; then
78		wl=-Wl,
79		ld="${CC}"
80		ldflags="${CFLAGS_vmlinux}"
81		ldlibs="-lutil -lrt -lpthread"
82	else
83		wl=
84		ld="${LD}"
85		ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
86		ldlibs=
87	fi
88
89	ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
90
91	# The kallsyms linking does not need debug symbols included.
92	if [ -n "${strip_debug}" ] ; then
93		ldflags="${ldflags} ${wl}--strip-debug"
94	fi
95
96	if is_enabled CONFIG_VMLINUX_MAP; then
97		ldflags="${ldflags} ${wl}-Map=${output}.map"
98	fi
99
100	${ld} ${ldflags} -o ${output}					\
101		${wl}--whole-archive ${objs} ${wl}--no-whole-archive	\
102		${wl}--start-group ${libs} ${wl}--end-group		\
103		${kallsymso} ${btf_vmlinux_bin_o} ${ldlibs}
104}
105
106# generate .BTF typeinfo from DWARF debuginfo
107# ${1} - vmlinux image
108gen_btf()
109{
110	local pahole_ver
111	local btf_data=${1}.btf.o
112
113	if ! [ -x "$(command -v ${PAHOLE})" ]; then
114		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
115		return 1
116	fi
117
118	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
119	if [ "${pahole_ver}" -lt "116" ]; then
120		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
121		return 1
122	fi
123
124	info BTF "${btf_data}"
125	LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
126
127	# Create ${btf_data} which contains just .BTF section but no symbols. Add
128	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
129	# deletes all symbols including __start_BTF and __stop_BTF, which will
130	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
131	# objcopy warnings: "empty loadable segment detected at ..."
132	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
133		--strip-all ${1} "${btf_data}" 2>/dev/null
134	# Change e_type to ET_REL so that it can be used to link final vmlinux.
135	# GNU ld 2.35+ and lld do not allow an ET_EXEC input.
136	if is_enabled CONFIG_CPU_BIG_ENDIAN; then
137		et_rel='\0\1'
138	else
139		et_rel='\1\0'
140	fi
141	printf "${et_rel}" | dd of="${btf_data}" conv=notrunc bs=1 seek=16 status=none
142
143	btf_vmlinux_bin_o=${btf_data}
144}
145
146# Create ${2}.o file with all symbols from the ${1} object file
147kallsyms()
148{
149	local kallsymopt;
150
151	if is_enabled CONFIG_KALLSYMS_ALL; then
152		kallsymopt="${kallsymopt} --all-symbols"
153	fi
154
155	if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
156		kallsymopt="${kallsymopt} --absolute-percpu"
157	fi
158
159	if is_enabled CONFIG_LTO_CLANG; then
160		kallsymopt="${kallsymopt} --lto-clang"
161	fi
162
163	info KSYMS "${2}.S"
164	scripts/kallsyms ${kallsymopt} "${1}" > "${2}.S"
165
166	info AS "${2}.o"
167	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
168	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} -c -o "${2}.o" "${2}.S"
169
170	kallsymso=${2}.o
171}
172
173# Perform kallsyms for the given temporary vmlinux.
174sysmap_and_kallsyms()
175{
176	mksysmap "${1}" "${1}.syms"
177	kallsyms "${1}.syms" "${1}.kallsyms"
178
179	kallsyms_sysmap=${1}.syms
180}
181
182# Create map file with all symbols from ${1}
183# See mksymap for additional details
184mksysmap()
185{
186	info NM ${2}
187	${NM} -n "${1}" | sed -f "${srctree}/scripts/mksysmap" > "${2}"
188}
189
190sorttable()
191{
192	${objtree}/scripts/sorttable ${1}
193}
194
195cleanup()
196{
197	rm -f .btf.*
198	rm -f System.map
199	rm -f vmlinux
200	rm -f vmlinux.map
201}
202
203# Use "make V=1" to debug this script
204case "${KBUILD_VERBOSE}" in
205*1*)
206	set -x
207	;;
208esac
209
210if [ "$1" = "clean" ]; then
211	cleanup
212	exit 0
213fi
214
215${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
216
217btf_vmlinux_bin_o=
218kallsymso=
219strip_debug=
220
221if is_enabled CONFIG_KALLSYMS; then
222	kallsyms /dev/null .tmp_vmlinux0.kallsyms
223fi
224
225if is_enabled CONFIG_KALLSYMS || is_enabled CONFIG_DEBUG_INFO_BTF; then
226
227	# The kallsyms linking does not need debug symbols, but the BTF does.
228	if ! is_enabled CONFIG_DEBUG_INFO_BTF; then
229		strip_debug=1
230	fi
231
232	vmlinux_link .tmp_vmlinux1
233fi
234
235if is_enabled CONFIG_DEBUG_INFO_BTF; then
236	if ! gen_btf .tmp_vmlinux1; then
237		echo >&2 "Failed to generate BTF for vmlinux"
238		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
239		exit 1
240	fi
241fi
242
243if is_enabled CONFIG_KALLSYMS; then
244
245	# kallsyms support
246	# Generate section listing all symbols and add it into vmlinux
247	# It's a four step process:
248	# 0)  Generate a dummy __kallsyms with empty symbol list.
249	# 1)  Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
250	#     with a dummy __kallsyms.
251	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
252	#     the right size
253	# 2)  Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
254	#     the right size, but due to the added section, some
255	#     addresses have shifted.
256	#     From here, we generate a correct .tmp_vmlinux.kallsyms2.o
257	# 3)  That link may have expanded the kernel image enough that
258	#     more linker branch stubs / trampolines had to be added, which
259	#     introduces new names, which further expands kallsyms. Do another
260	#     pass if that is the case. In theory it's possible this results
261	#     in even more stubs, but unlikely.
262	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
263	#     other bugs.
264	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
265	#
266	# a)  Verify that the System.map from vmlinux matches the map from
267	#     ${kallsymso}.
268
269	# The kallsyms linking does not need debug symbols included.
270	strip_debug=1
271
272	sysmap_and_kallsyms .tmp_vmlinux1
273	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
274
275	vmlinux_link .tmp_vmlinux2
276	sysmap_and_kallsyms .tmp_vmlinux2
277	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
278
279	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
280		vmlinux_link .tmp_vmlinux3
281		sysmap_and_kallsyms .tmp_vmlinux3
282	fi
283fi
284
285strip_debug=
286
287vmlinux_link vmlinux
288
289# fill in BTF IDs
290if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
291	info BTFIDS vmlinux
292	${RESOLVE_BTFIDS} vmlinux
293fi
294
295mksysmap vmlinux System.map
296
297if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
298	info SORTTAB vmlinux
299	if ! sorttable vmlinux; then
300		echo >&2 Failed to sort kernel tables
301		exit 1
302	fi
303fi
304
305# step a (see comment above)
306if is_enabled CONFIG_KALLSYMS; then
307	if ! cmp -s System.map "${kallsyms_sysmap}"; then
308		echo >&2 Inconsistent kallsyms data
309		echo >&2 'Try "make KALLSYMS_EXTRA_PASS=1" as a workaround'
310		exit 1
311	fi
312fi
313
314# For fixdep
315echo "vmlinux: $0" > .vmlinux.d
316